//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
#include "bbstdVectorFilterString.h"
#include "bbstdPackage.h"
namespace bbstd
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(std,VectorFilterString)
BBTK_BLACK_BOX_IMPLEMENTATION(VectorFilterString,bbtk::AtomicBlackBox);
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 

void VectorFilterString::ConnectionRepetitions( std::vector<std::string> vIn,std::vector<std::string> *vOut  )
{
	int i,size=vIn.size();
	int itmp=0, acum=0;
	std::string stmp;
	for( i=0;i<size;i++)
	{
		if (vIn[i].compare( vIn[itmp])==0) 
		{
			acum++;
		} else {
			itmp=i;
			vOut->push_back(std::to_string(acum));
			acum=1;
		}
	} // for
	vOut->push_back(std::to_string(acum));
}

void VectorFilterString::FilterByFindinIn0()
{
	std::vector<std::string> vOut0;
	std::vector<std::string> vOut1;
	std::vector<std::string> vOut2;
	std::vector<std::string> vOut3;
	std::vector<std::string> vOut4;
	std::vector<std::string> vOut5;
	std::vector<std::string> vOut6;
	std::vector<std::string> vOut7;
	std::vector<std::string> vOut8;
	std::vector<std::string> vOut9;

	int i,size = bbGetInputIn0().size();
	int pos;
	for (i=0; i<size; i++)
	{
		pos=bbGetInputIn0()[i].find( bbGetInputsk1());
		if (  pos  >= 0)
		{
			vOut0.push_back( bbGetInputIn0()[i] );
			if ( i < bbGetInputIn1().size() ) { vOut1.push_back( bbGetInputIn1()[i] ); }
			if ( i < bbGetInputIn2().size() ) { vOut2.push_back( bbGetInputIn2()[i] ); }
			if ( i < bbGetInputIn3().size() ) { vOut3.push_back( bbGetInputIn3()[i] ); }
			if ( i < bbGetInputIn4().size() ) { vOut4.push_back( bbGetInputIn4()[i] ); }
			if ( i < bbGetInputIn5().size() ) { vOut5.push_back( bbGetInputIn5()[i] ); }
			if ( i < bbGetInputIn6().size() ) { vOut6.push_back( bbGetInputIn6()[i] ); }
			if ( i < bbGetInputIn7().size() ) { vOut7.push_back( bbGetInputIn7()[i] ); }
			if ( i < bbGetInputIn8().size() ) { vOut8.push_back( bbGetInputIn8()[i] ); }
			if ( i < bbGetInputIn9().size() ) { vOut9.push_back( bbGetInputIn9()[i] ); }
		} // if pos
	} // for i
	
	bbSetOutputOut0( vOut0 );
	bbSetOutputOut1( vOut1 );
	bbSetOutputOut2( vOut2 );
	bbSetOutputOut3( vOut3 );
	bbSetOutputOut4( vOut4 );
	bbSetOutputOut5( vOut5 );
	bbSetOutputOut6( vOut6 );
	bbSetOutputOut7( vOut7 );
	bbSetOutputOut8( vOut8 );
	bbSetOutputOut9( vOut9 );
}

void VectorFilterString::InsertStringPos()
{
    std::vector<std::string> vOut0;
    std::vector<std::string> vOut1;
    std::vector<std::string> vOut2;
    std::vector<std::string> vOut3;
    std::vector<std::string> vOut4;
    std::vector<std::string> vOut5;
    std::vector<std::string> vOut6;
    std::vector<std::string> vOut7;
    std::vector<std::string> vOut8;
    std::vector<std::string> vOut9;
    int i,size      = bbGetInputIn0().size();
    std::string sk1 = bbGetInputsk1();
    int pos         = atoi( bbGetInputsk2().c_str() );
    for (i=0; i<size; i++)
    {
        vOut0.push_back( bbGetInputIn0()[i].insert(pos,sk1) );
        if ( i < bbGetInputIn1().size() ) { vOut1.push_back( bbGetInputIn1()[i].insert(pos,sk1) ); }
        if ( i < bbGetInputIn2().size() ) { vOut2.push_back( bbGetInputIn2()[i].insert(pos,sk1) ); }
        if ( i < bbGetInputIn3().size() ) { vOut3.push_back( bbGetInputIn3()[i].insert(pos,sk1) ); }
        if ( i < bbGetInputIn4().size() ) { vOut4.push_back( bbGetInputIn4()[i].insert(pos,sk1) ); }
        if ( i < bbGetInputIn5().size() ) { vOut5.push_back( bbGetInputIn5()[i].insert(pos,sk1) ); }
        if ( i < bbGetInputIn6().size() ) { vOut6.push_back( bbGetInputIn6()[i].insert(pos,sk1) ); }
        if ( i < bbGetInputIn7().size() ) { vOut7.push_back( bbGetInputIn7()[i].insert(pos,sk1) ); }
        if ( i < bbGetInputIn8().size() ) { vOut8.push_back( bbGetInputIn8()[i].insert(pos,sk1) ); }
        if ( i < bbGetInputIn9().size() ) { vOut9.push_back( bbGetInputIn9()[i].insert(pos,sk1) ); }
    } // for i
    bbSetOutputOut0( vOut0 );
    bbSetOutputOut1( vOut1 );
    bbSetOutputOut2( vOut2 );
    bbSetOutputOut3( vOut3 );
    bbSetOutputOut4( vOut4 );
    bbSetOutputOut5( vOut5 );
    bbSetOutputOut6( vOut6 );
    bbSetOutputOut7( vOut7 );
    bbSetOutputOut8( vOut8 );
    bbSetOutputOut9( vOut9 );
}



void VectorFilterString::Process()
{

// THE MAIN PROCESSING METHOD BODY
//   Here we simply set the input 'In' value to the output 'Out'
//   And print out the output value
// INPUT/OUTPUT ACCESSORS ARE OF THE FORM :
//    void bbSet{Input|Output}NAME(const TYPE&)
//    const TYPE& bbGet{Input|Output}NAME() const 
//    Where :
//    * NAME is the name of the input/output
//      (the one provided in the attribute 'name' of the tag 'input')
//    * TYPE is the C++ type of the input/output
//      (the one provided in the attribute 'type' of the tag 'input')

//    bbSetOutputOut( bbGetInputIn() );
//    std::cout << "Output value = " <<bbGetOutputOut() << std::endl;
  
	if (bbGetInputType()==0) 
	{
		std::vector<std::string> vOut0;
		std::vector<std::string> vOut1;
		std::vector<std::string> vOut2;
		std::vector<std::string> vOut3;
		std::vector<std::string> vOut4;
		std::vector<std::string> vOut5;
		std::vector<std::string> vOut6;
		std::vector<std::string> vOut7;
		std::vector<std::string> vOut8;
		std::vector<std::string> vOut9;
		ConnectionRepetitions( bbGetInputIn0() , &vOut0 );
		ConnectionRepetitions( bbGetInputIn1() , &vOut1 );
		ConnectionRepetitions( bbGetInputIn2() , &vOut2 );
		ConnectionRepetitions( bbGetInputIn3() , &vOut3 );
		ConnectionRepetitions( bbGetInputIn4() , &vOut4 );
		ConnectionRepetitions( bbGetInputIn5() , &vOut5 );
		ConnectionRepetitions( bbGetInputIn6() , &vOut6 );
		ConnectionRepetitions( bbGetInputIn7() , &vOut7 );
		ConnectionRepetitions( bbGetInputIn8() , &vOut8 );
		ConnectionRepetitions( bbGetInputIn9() , &vOut9 );
		bbSetOutputOut0( vOut0 );
		bbSetOutputOut1( vOut1 );
		bbSetOutputOut2( vOut2 );
		bbSetOutputOut3( vOut3 );
		bbSetOutputOut4( vOut4 );
		bbSetOutputOut5( vOut5 );
		bbSetOutputOut6( vOut6 );
		bbSetOutputOut7( vOut7 );
		bbSetOutputOut8( vOut8 );
		bbSetOutputOut9( vOut9 );
	}

    if (bbGetInputType()==2)
    {
        FilterByFindinIn0();
    }

    if (bbGetInputType()==3)
    {
        InsertStringPos();
    }
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void VectorFilterString::bbUserSetDefaultValues()
{

//  SET HERE THE DEFAULT INPUT/OUTPUT VALUES OF YOUR BOX 
//    Here we initialize the input 'In' to 0
   bbSetInputType(0);
   bbSetInputsk1("");
   bbSetInputsk2("");
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void VectorFilterString::bbUserInitializeProcessing()
{

//  THE INITIALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should allocate the internal/output pointers 
//    if any 

  
}
//===== 
// Before editing this file, make sure it's a file of your own (i.e.: it wasn't generated from xml description; if so : your modifications will be lost)
//===== 
void VectorFilterString::bbUserFinalizeProcessing()
{

//  THE FINALIZATION METHOD BODY :
//    Here does nothing 
//    but this is where you should desallocate the internal/output pointers 
//    if any
  
}

} // EO namespace bbstd


